//-------------------------------------------------------------------=72
//
// Copyright (C) Columbia University, 1998-1999. All Rights Reserved.
//
//-------------------------------------------------------------------=72
//
// RVMainFrame.cpp : implementation of the RVMainFrame class
//
//-------------------------------------------------------------------=72
//
// Author:				 Tomoo Mitsunaga
//
// Version:              1.0
//
// Modification History:
//  Dec/05/1998:	Created	
//
// Bugs:
//
//-------------------------------------------------------------------=72

#include "stdafx.h"
#include "radianceView.h"

#include "RVMainFrame.h"
#include "RVView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// RVMainFrame

IMPLEMENT_DYNCREATE(RVMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(RVMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(RVMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_EQ_WHOLE, OnViewEqWhole)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// RVMainFrame construction/destruction

RVMainFrame::RVMainFrame()
{
	// TODO: add member initialization code here
}

RVMainFrame::~RVMainFrame()
{
}

int RVMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	CMenu* menu=GetMenu( );
	menu->CheckMenuItem(ID_VIEW_EQ_WHOLE,MF_UNCHECKED);
	mMenuViewEqChecked=MF_CHECKED;

	return 0;
}

BOOL RVMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// RVMainFrame diagnostics

#ifdef _DEBUG
void RVMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void RVMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// RVMainFrame message handlers

void RVMainFrame::OnViewEqWhole() 
{
	// TODO: Add your command handler code here
	CMenu* menu=GetMenu( );
	mMenuViewEqChecked=menu->CheckMenuItem(ID_VIEW_EQ_WHOLE,mMenuViewEqChecked);

	RVView *view=(RVView*)GetActiveView();
	view->OnViewEqWhole();
}

//-------------------------------------------------------------------=72
// End of RVMainFrame.cpp
//-------------------------------------------------------------------=72
